clear
clc
load data;
%protein_position_sequence: the protein(UniProt ID),modification position and 21-length local sequences data on S/T sites 
%namemap: the eight phosphorylation kinase groups,O-GalNAc,O-GlcNAc and acetylation mapping to 11 columns in the SMNet 
%SMNet_s: SMNet matrix on S sites
%SMNet_t: SMNet matrix on T sites
m1=size(pro_pos_seq_t,1);
m2=size(pro_pos_seq_s,1);
Aa='CSTPAGNDEQHRKMILVFYW*';
seq_simi=[];
%taken the data on T sites as an example
for i=1:m1       %binary encoding
   pep = zeros(1,length(Aa)*21);
   for k = 1:21
       peptide=pro_pos_seq_t{i,3};      
       pp = ismember(Aa,peptide(k));
       pep(length(Aa)*(k-1)+1:length(Aa)*k) = pp;
   end
   seq_simi=[seq_simi;pep];
end
 for i=1:11

    label=SMNet_t(:,i);
    cmd=[' -w1 ',num2str(sum(label==0)/sum(label==1)),' -w0 ',num2str(1)];
    [deci,label_y]=get_cv_deci(label,SMNet_t,seq_simi,i,cmd,10);
    [auc1,sn1,sp1,acc1,pre1,mcc1] = roc(deci(:,1),label,'-r'); % the ROC curve plot of seq_simi+SMNet_t
    svmauc_all{i,1}=auc1;
    svmsn{i,1}=sn1;
    svmsp{i,1}=sp1;
    acc{i,1}=acc1;
    pre{i,1}=pre1;
    mcc{i,1}=mcc1;
    hold on;
    [auc2,sn2,sp2,acc2,pre2,mcc2] = roc(deci(:,2),label,'-b');% the ROC curve plot of seq_simi
     auc_all{i,1}=auc2;
     sn{i,1}=sn2;
     sp{i,1}=sp2;
     acc{i,1}=acc2;
     pre{i,1}=pre2;
     mcc{i,1}=mcc2;     
    title(namemap{i,2});
    legend(['SMNet+SEQ=',num2str(auc1)],['SEQ=',num2str(auc2)],'Location','SouthEast');
    saveas(gcf,['.\',namemap{i,2},'.tif']);
    hold off;
 end
  save auc__t auc_all;
  save sn__t sn;
  save sp__t sp;
  save acc__t acc; 
  save pre__t pre;
  save mcc__t mcc;
  save deci_t deci;

